require 'high_skills/ruby_high_skill.rb'
include_class Java::sk.fiit.jim.math.Angles
include_class Java::java.lang.Math

class Walk < RubyHighSkill
  
  #270 - 330 degrees
  @@right_range = (1.5*Math::PI)..((11.0/6.0)*Math::PI)
  #30 - 90 degrees
  @@left_range = ((1.0/6.0)*Math::PI)..(0.5*Math::PI)
  #75 - 90 degrees
  @@left_strafe_range = ((5.0/12.0)*Math::PI..(0.5*Math::PI))
  #270 - 285 degrees
  @@right_strafe_range = (1.5*Math::PI..(19.0/12.0)*Math::PI)
  @@strafe_distance = 1.5
  
  
  def initialize target
    super()
    @target = target
  end
  
  def pickLowSkill
    target_position = @target
    target_position = (ball relative position) if @target == :ball
    target_position = target_position.set_z(0.0)
    return nil if close_enough?(target_position)
    return get_skill("walk") if straight?(target_position)
    return get_skill("walk_back") if back?(target_position)
    return get_skill("strafe_left") if left_and_close?(target_position)
    return get_skill("strafe_right") if right_and_close?(target_position)
    return get_skill("turn_left") if left_and_distant?(target_position)
    return get_skill("turn_right") if right_and_distant?(target_position)
  end
  
  def close_enough? target_position
    target_position.r < 0.5
  end
  
  def straight? target_position
    Angles.angle_diff(target_position.phi, 0.0) < Math::PI / 6.0 
  end
  
  def back? target_position
    Angles.angle_diff(target_position.phi, Math::PI) < Math::PI / 6.0
  end
  
  def left_and_close? target_position
    puts target_position
    (target_position.r <= @@strafe_distance) and @@left_strafe_range.include?(Angles.normalize(target_position.phi))
  end
  
  def right_and_close? target_position
    (target_position.r <= @@strafe_distance) and @@right_strafe_range.include?(Angles.normalize(target_position.phi))
  end
  
  def left_and_distant? target_position
    @@left_range.include?(Angles.normalize(target_position.phi))
  end
  
  def right_and_distant? target_position
    @@right_range.include?(Angles.normalize(target_position.phi))
  end
  
  def checkProgress
    raise "Fallen!" if me.on_ground?
  end
  
  def abs number
    Math.abs number
  end
end

#in order not to defer the startup cost
Walk.new :ball