########	plan.rb	 ########
#	@author: Androids		#
#############################

require 'singleton'
require 'thread'

lock = Mutex.new
lock.synchronize do 

class Plan
  include Singleton
  
  BEAMABLE = [EnvironmentModel::PlayMode::BEFORE_KICK_OFF, EnvironmentModel::PlayMode::GAME_OVER, EnvironmentModel::PlayMode::GOAL_LEFT,
      EnvironmentModel::PlayMode::GOAL_RIGHT, EnvironmentModel::PlayMode::KICK_OFF_LEFT, EnvironmentModel::PlayMode::KICK_OFF_RIGHT]
 
  BFFKICK = [EnvironmentModel::PlayMode::BEFORE_KICK_OFF]
  
  def initialize
    puts "Initializing!"
	@agentModel = Java::sk.fiit.jim.agent.models.AgentModel.getInstance
    @plan = []
    @queue = []
	@names = []
    @turned = false
    @beamed = false
	@isStanding = true
  end
  
  def control
  	if @plan.empty? or @plan[0].ended?
  		replan
    end
    
	unless @plan.empty?
		@plan[0].execute
    end
  end
  
  def replan
    @plan.clear
    
    if beamable_play_mode?
    	@plan << Beam.new
    	@beamed = true
    	return
    end

	@isStanding = (not @agentModel.isOnGround)
	if @isStanding
	
		### planning one move ###
		if @queue.empty?
			#@plan << LowSkill.new("padvpred")
			#@plan << LowSkill.new("padvzad")
			#@plan << LowSkill.new("walk_fine_fast2")
			#@plan << LowSkill.new("kick_straight_edge_r")
			#@plan << LowSkill.new("kick_right")
			#@plan << LowSkill.new("turnleft90")
			#@plan << LowSkill.new("turnleft90")
			#@plan << LowSkill.new("turn_left_cont_20")
			#@plan << LowSkill.new("turn_left_cont_5")
	
			#@plan << LowSkill.new("sit_down")
			#@plan << LowSkill.new("sit_stand")
			#@plan << LowSkill.new("turnleft90")
			#@plan << LowSkill.new("kick_right")
			#@plan << LowSkill.new("fall_right")
			
			#@plan << LowSkill.new("walk_fine_fast1")
			#@plan << LowSkill.new("walk_fine_fast2")
			#@plan << LowSkill.new("walk_fine_slow")
			#@plan << LowSkill.new("walk_fine_back")
			#@plan << LowSkill.new("walkback2")
			
			### planning several moves in a row ###
			#fillQueue
	    	return
	  	end
	  
      	unless @queue.empty?
	    	@plan << @queue.shift
	  	end
	  
	  	else
	  		@queue.clear
	  	
### stopped working for some reason TODO: check why? ###
### should be working when agent is laying on side   ###
#	  		if not @turned
#	  			@turned = true
#	  			@plan.clear
#	  			@plan << LowSkill.new("nachrbat")
#	  			return
#	  		end
	  	
	  		if @agentModel.isLyingOnBack
		  		@plan.clear
	  			@plan << LowSkill.new("stand_back")
	  			turned = false
	  			return
	  		end
	  	
	  		if @agentModel.isLyingOnBelly
				@plan.clear
	    		@plan << LowSkill.new("stand_back")
				turned = false
				return
	  		end
		end
  	end
  
  def reset
  	@plan.clear
  	@beamed = false
  end
  
  def beamable_play_mode?
  	mode = environment play_mode
  	BEAMABLE.each do |pmode|
    	return true if pmode === mode
    end
    return false
  end

  def fillQueue
  	### if want to use planning in Java -> uncomment ###
	#@names = Java::sk.fiit.jim.agent.Planner.getPlanedMoves
	#unless @names == nil
		#Java::sk.fiit.jim.agent.Planner.clearPlanedMoves
	  	#@names.size.times do |i|
	  		#@queue << LowSkill.new(@names[i])
		#end
    #end
     
	### used to create a queue in plan.rb ###
	#@queue << LowSkill.new("padvpred")
	#@queue << LowSkill.new("padvzad")
	#@queue << LowSkill.new("walk_fine_fast2")
	#@queue << LowSkill.new("kick_straight_edge_l")
	#@queue << LowSkill.new("kick_left")
	@queue << LowSkill.new("turnleft90")
	#@queue << LowSkill.new("turnleft90")
	#@queue << LowSkill.new("turn_left_cont_20")
	#@queue << LowSkill.new("turn_left_cont_5")

	#@queue << LowSkill.new("sit_down")
	#@queue << LowSkill.new("sit_stand")
	#@queue << LowSkill.new("turnleft90")
	@queue << LowSkill.new("kick_right")
	#@queue << LowSkill.new("fall_left")
	
	#@queue << LowSkill.new("walk_fine_fast1")
	#@queue << LowSkill.new("walk_fine_fast2")
	#@queue << LowSkill.new("walk_fine_slow")
	#@queue << LowSkill.new("walkback2")
	@queue << LowSkill.new("stepleft")
  
	return
  end
  
end

  #------------override Ruby's global logging => log PLANNING instead--------------
  
  def log message = ""
    Log.log LogType::PLANNING, message
  end

  def debug message = ""
    Log.debug LogType::PLANNING, message
  end

  def error message = ""
    Log.error LogType::PLANNING, message
  end
end

#reset on 2nd load => causing replan
Plan.instance.reset