package sk.fiit.jim.agent.models;

import static sk.fiit.jim.log.LogType.AGENT_MODEL;
import sk.fiit.jim.agent.parsing.ParsedData;
import sk.fiit.jim.agent.parsing.ParsedDataObserver;
import sk.fiit.jim.log.Log;
import sk.fiit.jim.math.Vector3D;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 *  WorldModel.java
 *  
 *  Data holder for objects on the playground. Carries information about
 *  their respective position, velocity and their average observed velocity.
 *
 *@Title	Jim
 *@author	marosurbanec
 *@author	Androids
 */
public class WorldModel implements ParsedDataObserver{
	private DynamicObject ball = new DynamicObject();
	private AgentModel agentModel;
	private static WorldModel instance = new WorldModel(AgentModel.getInstance());
	
	//added by Androids.
	//TODO: prediction of team and opponent players
	public Map<Integer, Player> teamPlayers = new HashMap<Integer, Player>();
	public Map<Integer, Player> opponentPlayers = new HashMap<Integer, Player>();
	
	public WorldModel(AgentModel model){
		this.agentModel = model;
	}
	
	public static WorldModel getInstance(){
		return instance;
	}
	
	//added by Androids
	//TODO: calculating who is on our team and who is the opponent.
	public void processNewServerMessage(ParsedData data){
		if (data.ballRelativePosition != null)
			calculateBallPosition(data);
		
		calculatePlayers(teamPlayers, data.SIMULATION_TIME);
		calculatePlayers(opponentPlayers, data.SIMULATION_TIME);
	}
	
	//added by Androids
	public void calculatePlayers(Map<Integer, Player> playersAll, double timeSeen) {
		Log.log(AGENT_MODEL, "Player IDs are not implemented yet!!!");
	}//TODO: calculating who is on our team and who is the opponent.
	
	//added by Androids
	public void calculateBallPosition(ParsedData data){
		returnBallRelativePosition(data.ballRelativePosition, data.SIMULATION_TIME);
	}
	
	//added by Androids
	public void returnBallRelativePosition(Vector3D ballRelativePosition, double simulationTime) {
		ball.setRelativePosition(ballRelativePosition, simulationTime);
		Vector3D absolutePosition = agentModel.globalize(ballRelativePosition);
		ball.setPosition(absolutePosition, simulationTime);
	}

	public DynamicObject getBall(){
		return ball;
	}
	
	public void setAgentModel(AgentModel agent){
		this.agentModel = agent;
	}
	
	//added by Androids
	public List<Player> getTeamPlayers() {
		return new ArrayList<Player>(teamPlayers.values());
	}

	//added by Androids
	public List<Player> getOpponentPlayers() {
		return new ArrayList<Player>(opponentPlayers.values());
	}
}