package sk.fiit.jim.agent.moves;

import java.util.HashMap;
import java.util.Map;

/**
 *  LowSkills.java
 *  
 *  Serves as a cache for all low skills found in XMLs in ROOT/moves directory 
 *
 *@Title	Jim
 *@author	marosurbanec
 */
public final class LowSkills{
	private LowSkills(){}
	static private Map<String, LowSkill> skills = new HashMap<String, LowSkill>();
	
	public static void addSkill(LowSkill skill){
		if (skill == null) return;
		skills.put(skill.name, skill);
	}
	
	public static boolean exists(String name){
		return skills.containsKey(name);
	}
	
	public static LowSkill get(String name){
		return skills.get(name);
	}
	
	public static void reset(){
		for (LowSkill skill : skills.values())
			skill.activePhase = null;
	}
}