package sk.fiit.jim.agent.moves;

import java.util.HashMap;
import java.util.Map;

/**
 *  Phases.java
 *  
 *  Cache for phases.
 *
 *@Title	Jim
 *@author	marosurbanec
 */
public class Phases {

	private Phases(){}
	static private Map<String, Phase> skills = new HashMap<String, Phase>();
	
	public static void addPhase(Phase phase){
		if (phase != null)
			skills.put(phase.name, phase);
	}
	
	public static boolean exists(String name){
		if (Phase.EMPTY_PHASE.name.equals(name))
			return true;
		return skills.containsKey(name);
	}
	
	public static Phase get(String name){
		if (Phase.EMPTY_PHASE.name.equals(name))
			return Phase.EMPTY_PHASE;
		return skills.get(name);
	}
	
	public static void reset(){
		skills.clear();
	}
}