package sk.fiit.jim.agent.moves;

import java.util.HashMap;
import java.util.Map;

import sk.fiit.jim.code_review.ReviewOk;

/**
 *  SkipFlags.java
 *  
 *  Static class recording a "database" of a value of each flag => default
 *  value for any flag is FALSE. Provides querying methods on those values.
 *
 *@Title	Jim
 *@author	marosurbanec
 */
@ReviewOk
public class SkipFlags{
	private SkipFlags(){}
	private static Map<SkipFlag, Boolean> values = new HashMap<SkipFlag, Boolean>();
	
	public static boolean isTrue(SkipFlag flag){
		//do NOT autobox to 'boolean' => values may contain null, raising NullPointerException on autoboxing
		Boolean isSet = values.get(flag);
		return isSet != null && isSet == Boolean.TRUE;
	}
	
	public static void setTrue(SkipFlag flag){
		values.put(flag, Boolean.TRUE);
	}
	
	public static void setFalse(SkipFlag flag){
		values.put(flag, Boolean.FALSE);
	}
	
	public static void reset(){
		values.clear();
	}
}